close all;
clear all;

Fs =1000;
A = 1;
T=1;
t=[0: 1/Fs: T];
a=50;
b=10;
freqs = a*t+b;
x = A*cos(2*pi*t.*freqs);
subplot(2,1,1)
plot(t,x)
xlabel('Tempo');
ylabel('Amplitude');
title('x = A cos(2\pi f(t) t), f(t) = at+b');

subplot(2,1,2)
x2 = fliplr(x);
plot(t,x2)
xlabel('Tempo');
ylabel('Amplitude');
title('x = A cos(2\pi f(-t) t), f(t) = at+b');

figure;
subplot(2,1,1)
plot(t,freqs)
xlabel('Tempo');
ylabel('Amplitude');
title('f(t) = at+b');

subplot(2,1,2)
plot(t,fliplr(freqs))
xlabel('Tempo');
ylabel('Amplitude');
title('f(t) = -at+b');


figure;
subplot(2,2,1)
plot([-(length(t)-1)/2:1:(length(t)-1)/2], fftshift(abs(fft(x)))/max(abs(fft(x))))
xlabel('Frequencia')
ylabel('Espectro Normalizado de x');
subplot(2,2,2)
plot([-(length(t)-1)/2:1:(length(t)-1)/2], fftshift(angle(fft(x))))
xlabel('Frequencia')
ylabel('Fase do Espectro de x');

subplot(2,2,3)
plot([-(length(t)-1)/2:1:(length(t)-1)/2], fftshift(abs(fft(x2)))/max(abs(fft(x2))))
xlabel('Frequencia')
ylabel('Espectro Normalizado de x');
subplot(2,2,4)
plot([-(length(t)-1)/2:1:(length(t)-1)/2], fftshift(angle(fft(x2))))
xlabel('Frequencia')
ylabel('Fase do Espectro de x');

figure,spectrogram(x,128,120,128,1e3)
title('x = A cos(2\pi f(t) t), f(t) = at+b');
figure,spectrogram(x2,128,120,128,1e3)
title('x = A cos(2\pi f(-t) t), f(t) = at+b');

figure, spectrogram(x,100,80,100,Fs,'yaxis')
view(-77,72)
shading interp
colorbar off

figure, spectrogram(x2,100,80,100,Fs,'yaxis')
view(-77,72)
shading interp
colorbar off

